'============================================================================
'
'  aPCI-P33
'
'  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
'
'============================================================================
Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Apci33s

    Dim P33w As Apci33w

    Private Sub Apci33s_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim wLogSlot As Short       ' ޲̘_ۯĔԍi[
        Dim Ri As Apci33w.Resource  ' ؿ
        Dim dwDllVer As Integer, dwDrvVer As Integer
        Dim dwSwVal As Integer      ' ۰ذ̒l
        Dim cbDat As Byte
        Dim bResult As Boolean      ' 
        Dim szBuf As String
        Dim i As Integer

        ' 
        P33w = New Apci33w
        Ri = New Apci33w.Resource
        Ri.dwMemBase = New Integer(Apci33w.MAX_MEM) {}
        Ri.dwMemLength = New Integer(Apci33w.MAX_MEM) {}
        Ri.dwMemAttrib = New Integer(Apci33w.MAX_MEM) {}
        Ri.dwIOPortBase = New Integer(Apci33w.MAX_IO) {}
        Ri.dwIOPortLength = New Integer(Apci33w.MAX_IO) {}
        Ri.dwIRQRegisters = New Integer(Apci33w.MAX_IRQ) {}
        Ri.dwIRQAttrib = New Integer(Apci33w.MAX_IRQ) {}
        Ri.dwDMALst = New Integer(Apci33w.MAX_DMA) {}
        Ri.dwDMAAttrib = New Integer(Apci33w.MAX_DMA) {}
        Ri.dwReserved1 = New Integer(Apci33w.MAX_RSV) {}

        ' 
        Ri.dwNumMemWindows = 0
        For i = 0 To Apci33w.MAX_MEM
            Ri.dwMemBase(i) = 0
            Ri.dwMemLength(i) = 0
            Ri.dwMemAttrib(i) = 0
        Next
        Ri.dwNumIOPorts = 0
        For i = 0 To Apci33w.MAX_IO
            Ri.dwIOPortBase(i) = 0
            Ri.dwIOPortLength(i) = 0
        Next
        Ri.dwNumIRQs = 0
        For i = 0 To Apci33w.MAX_IRQ
            Ri.dwIRQRegisters(i) = 0
            Ri.dwIRQAttrib(i) = 0
        Next
        Ri.dwNumDMAs = 0
        For i = 0 To Apci33w.MAX_DMA
            Ri.dwDMALst(i) = 0
            Ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci33w.MAX_RSV
            Ri.dwReserved1(i) = 0
        Next

        '-------------------------------------------------
        ' ްޮݔԍ\
        ' aPCI-P33 DLL,ײްްޮݔԍ擾
        '-------------------------------------------------
        If P33w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Apci33w.SLOT_AUTO)
            Exit Sub
        End If
        szBuf = String.Concat("Version", vbCrLf, _
                                String.Format("DLL: 0x{0:x8}", dwDllVer), vbCrLf, _
                                String.Format("DRV: 0x{0:x8}", dwDrvVer))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' aPCI-P33̎gp錾
        '-------------------------------------------------
        wLogSlot = Apci33w.SLOT_AUTO        ' gp޲T܂B
        bResult = P33w.Create(wLogSlot)     ' ꍇA̎޲̘_ۯĔԍi[܂B

        If bResult = False Then             ' ޲܂B
            ErrorMessage(Apci33w.SLOT_AUTO)
            Exit Sub
        End If
        szBuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSlot))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' ؿ۰ذ̒l擾
        '-------------------------------------------------
        If P33w.GetResource(wLogSlot, Ri) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        If P33w.GetSwitchValue(wLogSlot, dwSwVal) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        szBuf = String.Concat("Resource", vbCrLf, _
                                String.Format("IO Address: {0:x4}h - {1:x4}h", _
                                                Ri.dwIOPortBase(0), _
                                                Ri.dwIOPortBase(0) + Ri.dwIOPortLength(0) - 1), vbCrLf, _
                                String.Format("Switch    : {0:x}h", dwSwVal))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' Port 1 ɔCӂްo
        '-------------------------------------------------
        cbDat = &H55
        If P33w.OutPort(wLogSlot, Apci33w.PORT_1, cbDat) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        szBuf = String.Concat("Port 1 փf[^o", vbCrLf, _
                                String.Format("Port 1 Out Data: {0:x}h", cbDat))
        ResultMessage(szBuf)
        '-------------------------------------------------
        ' aPCI-P33̎gpJ
        '-------------------------------------------------
        If P33w.Close(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    '============================================================================
    '    ʂ\
    '============================================================================
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub
    '============================================================================
    '    G[bZ[W\
    '============================================================================
    Private Sub ErrorMessage(ByVal wLogSlot As Integer)
        Dim dwRes As Long
        Dim szBuf As String

        dwRes = P33w.GetLastError(wLogSlot)
        Select Case dwRes
            Case Apci33w.ERR_SYSTEM, Apci33w.ERR_WRAPDLL
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
            Case Else
                szBuf = String.Concat("aPCI-P33 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
