Attribute VB_Name = "apci33"
'-----------------------------------------------------------------------
'       APCI-P33 Win32 API.
'-----------------------------------------------------------------------

Option Explicit

' Errors

Global Const APCI33_SUCCESS = 0                ' ُȂ
Global Const APCI33_ERR_SYSTEM = 1             ' GetLastError sĂ
Global Const APCI33_ERR_NO_DEVICE = 2          ' gp\ȃfoCXȂ
Global Const APCI33_ERR_IN_USE = 3             ' w肳ꂽۯĂ͎gp
Global Const APCI33_ERR_INVALID_SLOT = 4       ' ȁi_jۯĔԍ
Global Const APCI33_ERR_RESOURCE = 5           ' \[XG[
Global Const APCI33_ERR_INVALID_PORT = 6       ' ȃ|[gԍ
Global Const APCI33_ERR_INVALID_ARGUMENT = 7   ' Ȉ
Global Const APCI33_ERR_NO_CREATE = 8          ' foCXNGCgĂ܂

' aPCI-P33 card's relative port address

Global Const APCI33_PORT_1 = 0
Global Const APCI33_PORT_2 = 1
Global Const APCI33_PORT_3 = 2
Global Const APCI33_PORT_4 = 3
Global Const APCI33_PORT_5 = 4
Global Const APCI33_PORT_6 = 5
Global Const APCI33_PORT_7 = 6
Global Const APCI33_PORT_8 = 7

' Miscellaneous

Global Const APCI33_MAX_SLOTS = 16             ' T|[g{[h

Global Const APCI33_MAX_PORTS = 8              ' ANZX\ȃ|[g

Global Const APCI33_SLOT_AUTO = &HFFFF         '

' Resource infomation structure

Global Const APCI33_MAX_MEM = 9
Global Const APCI33_MAX_IO = 20
Global Const APCI33_MAX_DMA = 7

Type APCI33RESOURCE
    dwNumMemWindows As Long                           ' س޳       gp
    dwMemBase(1 To APCI33_MAX_MEM) As Long          ' س޳ްڽgp
    dwMemLength(1 To APCI33_MAX_MEM) As Long        ' س޳       gp
    dwMemAttrib(1 To APCI33_MAX_MEM) As Long        ' س޳     gp
    dwNumIOPorts As Long                              ' I/O߰Đ
    dwIOPortBase(1 To APCI33_MAX_IO) As Long        ' I/O߰ްڽ
    dwIOPortLength(1 To APCI33_MAX_IO) As Long      ' I/O߰Ē
    dwNumDMAs As Long                                 ' DMAِ         gp
    dwDMALst(1 To APCI33_MAX_DMA) As Long           ' DMAؽ        gp
    dwDMAAttrib(1 To APCI33_MAX_DMA) As Long        ' DMAّؽ    gp
    dwReserved1(1 To 3) As Long                       ' \              gp
End Type

Declare Function Apci33GetVersion Lib "apci33" (pdwDllVersion As Long, pdwVxdVersion As Long) As Long
Declare Function Apci33Create Lib "apci33" (pwLogSlot As Integer) As Long
Declare Function Apci33Close Lib "apci33" (ByVal wLogSlot As Integer) As Long
Declare Function Apci33GetResource Lib "apci33" (ByVal wLogSlot As Integer, pres As APCI33RESOURCE) As Long
Declare Function Apci33GetSwitchValue Lib "apci33" (ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Long
Declare Function Apci33OutPort Lib "apci33" (ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Long
Declare Function Apci33GetLastError Lib "apci33" (ByVal wLogSlot As Integer) As Long



